////////////////////////////////////////////////////////////////////////////////
// Assembly Language Demo - Converts string to uppercase  by Athlor
////////////////////////////////////////////////////////////////////////////////
#include "Pager.h"

char VersionPtr[] = "AsmDemo1";
int AppStackSize = 2000;

extern char *szUpper(char *);

void puts(char *s)
{
  LcdConfig lcdConf;
  LcdGetConfig (&lcdConf);
  LcdScroll(8);
  LcdPutStringXY(0, lcdConf.height-8, s, -1, TEXT_NORMAL);
}

void PagerMain(void)
{
  MESSAGE msg;
  char x=0;
  char txt[]="Assembly Language Demo 1";

  puts(txt);           // Plain string
  puts(szUpper(txt));  // Modified string

  do{
    RimGetMessage(&msg); // Get Message
    switch (msg.Device)
    {
      case DEVICE_KEYPAD:
        switch (msg.Event)
        {
          case KEY_DOWN:
            if(msg.SubMsg==' ') x=1;
            else puts("Press [space] to exit...");
        }
    }
  }while(x==0);
}
