////////////////////////////////////////////////////////////////////////////////
// Assembly Language Demo 2 - Power of 2 (Microsoft example) and sqr   by Athlor
////////////////////////////////////////////////////////////////////////////////
#include "Pager.h"

char VersionPtr[] = "AsmDemo3";
int AppStackSize = 1000;

int power2(int num, int power)
{
__asm
  {
    mov eax, num   ; Get first argument
    mov ecx, power ; Get second argument
    shl eax, cl    ; EAX = EAX * (2 to the power of CL)
  } // Return with result in EAX
}

int sqr(int num)
{
__asm
  {
    mov eax, num ; Get argument
    mul eax      ; EAX = EAX * EAX
  } // Return with result in EAX
}

void PagerMain(void)
{
 char x=0; // Exit
 MESSAGE msg;
 char txt[48];
  RimSprintf(txt,46,"3x2 to the power of 6 = %d",power2(3,6));
  LcdPutStringXY(0,16,txt,-1,0);
  RimSprintf(txt,46,"The square of 7 = %d",sqr(7));
  LcdPutStringXY(0,24,txt,-1,0);

  do{
    RimGetMessage(&msg); // Get Message
    switch (msg.Device)
    {
      case DEVICE_KEYPAD:
        switch (msg.Event)
        {
          case KEY_DOWN:
            if(msg.SubMsg==' ') x=1;
            else LcdPutStringXY(0,32,"Press <space> to exit...",-1,0);
        }
    }
  }while(x==0);
}
