#include <CyWin.h>

char d=25;      // Char gfx
char x=51,y=31; // Char starting pos

char m[128][128];      // Map (16384 bytes)
char tx[]= {-1,0,1,0}; // Left, Up, Right, Down
char ty[]= {0,-1,0,1}; // Left, Up, Right, Down

struct Input* AI; // Archive input
struct Message* MSG;
struct module_t MM;

int _getch(void)
{
int key=0;
 do{
   MSG=cWinApp_get_message(MM.m_process,0,1,MSG_USER);
   if(MSG->msgid==MSG_KEYDOWN) key=Message_get_key_param(MSG)->scancode;
     else cWinApp_defproc(MM.m_process,MSG); // Default processing
   Message_delete(MSG);
 }while(!key);
return key;
}

void update(void)
{
int h,v;
 for(v=0;v<6;v++)
   for(h=0;h<8;h++)
     draw_lib(0,m[v+y-3][h+x-4],h*16,v*16,BM_NORMAL); // Draw map tile
 draw_lib(0,d,64,48,BM_NORMAL);  // Draw char
 DisplayGraphics_show(MM.m_gfx); // Update Display
}

long main(int argc, char* argv[], bool start)
{
int k; char a,b;             // Key pressed, temp xy
 init_module(&MM);           // Initialize module
 cWinApp_clear_screen();     // Clear screen
 AI=open_resource(1);        // Create AI & open map.dat
 Input_read(AI,m,16384);     // Load map
 Input_dtor(AI,FREE_MEMORY); // Destroy AI

 do{
   update();
   k=_getch(); // Wait until key is pressed
   a=0;b=0;
   if(k>263&&k<268) {d=k-240;a=x+tx[k-264];b=y+ty[k-264];}
   if(m[b][a]<4) {x=a;y=b;}
 }while(k!=KEY_ESC);

return 0L;
}

