////////////////////////////////////////////////////////////////////////////////
// Assembly Language Demo 2 - Converts string to UPPERCASE  by Athlor
////////////////////////////////////////////////////////////////////////////////
#include "Pager.h"

char VersionPtr[] = "AsmDemo2";
int AppStackSize = 1000;

char *szUpper(char *text) 
{ 
__asm{ 
    mov eax, text 
    dec eax 
@repeat: 
    add eax, 1 
    cmp BYTE PTR [eax], 0 
    je @end 
    cmp BYTE PTR [eax], "a" 
    jb @repeat 
    cmp BYTE PTR [eax], "z" 
    ja @repeat 
    sub BYTE PTR [eax], 32 
    jmp @repeat 
@end: 
    } 
  return text;    
} 

void PagerMain(void)
{
  MESSAGE msg;
  char x=0;
  char txt[]="Assembly Language Demo 2";

  LcdPutStringXY(0,24,txt,-1,0);          // Plain string
  LcdPutStringXY(0,32,szUpper(txt),-1,0); // Modified string

  do{
    RimGetMessage(&msg); // Get Message
    switch (msg.Device)
    {
      case DEVICE_KEYPAD:
        switch (msg.Event)
        {
          case KEY_DOWN:
            if(msg.SubMsg==' ') x=1;
            else LcdPutStringXY(0,40,"Press [space] to exit...",-1,0);
        }
    }
  }while(x==0);
}
